      SUBROUTINE  JRSCAN (CMDLIN,LENCMD)
C     (SYSTEM COMMAND LINE ACCESS)
C     RETURN IN THE INTEGER ARRAY CMDLIN(*) THE SYSTEM COMMAND
C     LINE ON WHICH PROGRAM OPTIONS ARE CODED.  THE ORIGIN OF
C     THIS LINE IS SYSTEM-DEPENDENT.
C     THE INTEGER FLAG LENCMD IS RETURNED AS FOLLOWS:
C
C     LENCMD .LT. 0 - ERROR CONDITION
C     LENCMD .EQ. 0 - SUCCESSFUL, BUT COMMAND LINE EMPTY
C     LENCMD .GT. 0 - SUCCESSFUL, AND LENCMD = NUMBER OF CHARACTERS
C                     RETURNED IN CMDLIN(*) AS A PACKED
C                     STRING.
C
C     THE END OF THE COMMAND LINE STRING IS SIGNALED BY
C     A ZERO WORD IN CMDLIN(*).
C     (19-AUG-84)
C
C     THE FOLLOWING CODE IS FOR THE VAX-11/780 WITH THE VMS REL. 1.6
C     OPERATING SYSTEM.  THE SYSTEM ROUTINE SYS$CLI RETURNS A
C     7-WORD CONTROL BLOCK.  WORD 3 CONTAINS THE LENGTH OF THE
C     COMMAND LINE STRING (WITH THE INVOKING PROGRAM NAME REMOVED,
C     LETTERS CONVERTED TO UPPER-CASE, AND TABS REMOVED), AND
C     WORD 4 CONTAINS THE ADDRESS OF THE STRING IN MEMORY.
C     THE %LOC FUNCTION IS USED TO FIND THE ADDRESS OF ITS
C     ARGUMENT, AND THE STRING IS THEN COPIED BYTE-BY-BYTE
C     INTO CMDLIN(*).  THE ROUTINE SYS$CLI IS DESCRIBED
C     IN THE VAX VMS RELEASE NOTES, VERSION 1.5 (WITH A CORRECTION
C     IN THE NOTES FOR VERSION 1.6).
C
C     IN ORDER TO PROVIDE OPTIONS ON A COMMAND LINE, IT IS
C     NECESSARY TO DEFINE A SYMBOL AT VMS COMMAND LANGUAGE
C     LEVEL WHICH CAN BE USED LIKE A COMMAND WORD.  THIS IS
C     DONE AS FOLLOWS:
C
C     $ SYMNAME:==$DEVICE:[DIRECTORY]PROGRAMNAME.EXE
C
C     AND INVOKED AS
C
C     $ SYMNAME ...OPTIONS...
C
C     THE DOLLAR SIGN PRECEDING THE DEVICE DESIGNATOR IS
C     REQUIRED.  THE DOLLAR IN COLUMN 1 IS THE PROMPT CHARACTER
C     WHICH MUST BE TYPED IF THE COMMAND LINE IS IN AN INDIRECT
C     COMMAND FILE.
C
C     EXTERNAL SYS$CLI
C     BYTE CMDLIN(1)
C     INTEGER REQBLK(7),OFFSET,LENCMD
C
C     INSERT THE FUNCTION CODE INTO WORD 1 OF THE REQUEST BLOCK.
C
C     REQBLK(1) = 1
C     CALL SYS$CLI (REQBLK)
C
C     FIND THE OFFSET IN MEMORY OF THE COMMAND LINE RELATIVE TO
C     CMDLIN(1), AND THEN COPY "LENCMD" CHARACTERS INTO
C     CMDLIN(*), ADDING A TERMINAL 0 BYTE.
C
C     LENCMD = REQBLK(3)
C     IF (LENCMD .LE. 0) GO TO 20
C     OFFSET = REQBLK(4) - %LOC(CMDLIN(1))
C     DO 10 I = 1,LENCMD
C     CMDLIN(I) = CMDLIN(I+OFFSET)
C  10 CONTINUE
C     CMDLIN(LENCMD+1) = 0
C  20 RETURN
C
C     The following version is for Unix.  The library routine
C     "p79arg" is used to retrieve the command line arguments
C     and reconstruct the command line.
C
      CHARACTER*255       ARGSTR
      INTEGER             LENCMD,CMDLIN(1),CHRTRM
C
      LENCMD = 0
      ARGSTR = ' '
      I =1
      N20001=IARGC()
      GO TO 20002
20001 I =I +1
20002 IF ((N20001-I ).LT.0) GO TO 20003
      CALL P79ARG(I,ARGSTR(LENCMD+1:))
      LENCMD = CHRTRM(ARGSTR) + 1
      GO TO 20001
20003 LENCMD = MAX0(0,LENCMD-1)
C     CALL F4MVC (ARGSTR,1,CMDLIN,1,LENCMD)
      CALL KARMOV (CMDLIN,1,ARGSTR,1,LENCMD)
C
      RETURN
      END
