#ifndef P79_H
#define P79_H 1

#include <stdio.h>
#include <string.h>

#if __STDC__
#define ARGS(plist)	plist
#else
#define ARGS(plist)	()
#endif


/* On most systems with GNU gcc, the run-time library is a native
pre-ANSI one, with no stdlib.h.  Too bad C doesn't have a non-failing
#include statement. */

#if  __STDC__ && !defined(__GNUC__)
#include <stdlib.h>
#endif /* __STDC__ */

/* CONS(a,b) should return ab, the concatenation of its arguments */
#if  __STDC__ || __APOGEE__
#define CONS(a,b) a##b
#else /* NOT __STDC__ || __APOGEE__ */
#define CONS(a,b) a/**/b
#endif /* __STDC__ || __APOGEE__ */

#ifdef ardent
#define FORTRAN(lcname,ucname)	ucname
#endif

#ifdef _IBMR2
#define FORTRAN(lcname,ucname)	lcname
#endif

#ifdef __hp9000s800
#define FORTRAN(lcname,ucname)	lcname
#endif

#ifndef FORTRAN
#define FORTRAN(lcname,ucname)	CONS(lcname,_)
#endif

#ifdef TRUE
#undef TRUE
#endif
#define TRUE	1

#ifdef FALSE
#undef FALSE
#endif
#define FALSE	0

#define MAX(a,b)		( ((a) > (b)) ? (a) : (b) )
#define MIN(a,b)		( ((a) < (b)) ? (a) : (b) )

/* To simplify modifications for other systems, we use typedefs
for Fortran INTEGER (FINT) and CHARACTER (FCHAR) data, and
access macros CH(),  REF(), and VAL().   The access macros
must be usable as both l-values and r-values.  */

#if ardent
/* Stardent Fortran passes CHARACTER data by descriptor. */
typedef int*	FINT;
typedef struct
{
    char        *address;
    int         length;
} *FCHAR;
#define CH(x,n)	((x->address)[n])/* n-th character of x */
#define FLEN(x)	(x->length)	/* declared length of CHARACTER string */
#define FLENARG(x) CONS(x,_len)	/* declared length of CHARACTER string */
#endif /* ardent */


#if __hp9000s500
/* The HP 9000/800 passes the lengths by value immediately following 
each CHARACTER argument. */
typedef int*	FINT;
typedef struct
{
    int		max_length;
    char	*curlenword;
    int		first_byte;
    int         length;
    char        *address;
} *FCHAR;
#define CH(x,n)	((x->address)[n])/* n-th character of x */
#define FLEN(x)	(x->length)	/* declared length of CHARACTER string */
#define FLENARG(x) CONS(x,_len)	/* declared length of CHARACTER string */
#endif /* __hp9000s500 */

#ifndef FLENARG
/* Most UNIX compilers pass CHARACTER data by the address of the first
byte, with the length passed as an additional argument at the end of the
Fortran-visible argument list. */
typedef int*	FINT;
typedef char*	FCHAR;
#define CH(x,n)	x[n]		/* n-th character of x */
#define FLEN(x)	CONS(x,_len)	/* declared length of CHARACTER string */
#define FLENARG(x) CONS(x,_len)	/* declared length of CHARACTER string */
#endif

#define INTVAL(x)	*x	/* value of x */
#define REF(x)	x		/* reference to (address of) x */
#define VAL(x)	*x		/* value of x */

char	*p79ftc ARGS((char *s, int n));

#if _IBMR2
#define getenv _getenv	/* need private version to avoid name conflict  */
			/* between Fortran and C getenv() library routines */
#endif /* _IBMR2 */

#endif /* P79_H */
