C$    (P79xxx Test)
C$    Test the p79xxx primitives; they provide an interface to
C$    host-dependent operating system facilities.
C$    (02-Mar-1991)
      CHARACTER*80        s
      INTEGER             holdat(11), holtim(8)
      DOUBLE PRECISION    p79sec, t1, t2
      INTEGER             a1text(80), cmdlin(80), fp, k, n
      INTEGER             nbitpc, nbitpw, nchrpw
      INTEGER             p79arc, p79clr, p79col, p79lin, stdout

      DATA                fp     / 1 /
      DATA                stdout / 6 /

      write (stdout,'('' Begin test of argument handling...'')')
      write (stdout,'('' p79arc: Argument count = '',I5)') p79arc()
      do 10 k = 0,p79arc()
           call p79arg (k,s)
           write (stdout,'('' p79arg: Argument '',I3,'' = '',A)') k, s
   10 continue
      call p79cmd (s,n)
      write (stdout,'('' p79cmd: command line = ['',A,'']'')') s(1:n)
      call p79gcl (cmdlin,80,n)
      call karupk (a1text,cmdlin,1,n)
      write (stdout,'('' p79gcl: command line = '',82a1)')
     x     '[', (a1text(k), k = 1,n), ']'
      write (stdout,'('' End test of argument handling'')')

      write (stdout,'(/'' Begin test of chmod() access...'')')
      s = '/tmp/foo.bar'
      call p79sys ('/bin/rm -f ' // s)
      open (unit=fp, file=s, status='unknown')
      write (fp,'('' This is file '',a)') s
      close (unit=fp)
      write (stdout,'('' p79chm: current access follows:'')')
      call p79sys ('ls -l ' // s)
      write (stdout,
     x     '('' p79chm: access should now be 0777 (rwxrwxrwx)'')')
      call p79chm(s,511)
      call p79sys ('ls -l ' // s)
      write (stdout,
     x     '('' p79chm: access should now be 0444 (r--r--r--)'')')
      call p79chm(s,292)
      call p79sys ('ls -l ' // s)
      write (stdout,'('' End test of chmod() access'')')

      write (stdout,'(/'' Begin test of date and time...'')')
      call p79dat(holdat)
      call chrhtc(s,holdat,1,11)
      write (stdout,'('' p79dat: date = '',a)') s(1:11)
      call p79tim(holtim)
      call chrhtc(s,holtim,1,8)
      write (stdout,'('' p79tim: time = '',a)') s(1:8)
      write (stdout,'('' End test of date and time'')')

      write (stdout,'(/'' Begin test of system definitions...'')')
      call p79def(nchrpw,nbitpc,nbitpw)
      write (stdout,'('' p79def: characters/word = '',I4)') nchrpw
      write (stdout,'('' p79def: bits/character  = '',I4)') nbitpc
      write (stdout,'('' p79def: bits/word       = '',I4)') nbitpw
      write (stdout,'('' End test of system definitions'')')

      write (stdout,'(/'' Begin test of hostname...'')')
      call p79hst(s)
      write (stdout,'('' p79hst: hostname = '',A)') s
      write (stdout,'('' End test of hostname'')')

      write (stdout,'(/'' Begin test of user name...'')')
      call p79log(s)
      write (stdout,'('' p79log: user name = '',A)') s
      write (stdout,'('' End test of user name'')')

      write (stdout,'(/'' Begin test of personal name...'')')
      call p79usr(s)
      write (stdout,'('' p79usr: personal name = '',A)') s
      write (stdout,'('' End test of personal name'')')

      write (stdout,'(/'' Begin test of p79sec...'')')
      t1 = p79sec()
      t2 = 0.0
      do 20 k = 1,100000
           t2 = t2 + sin(0.3)
   20 continue
      t2 = p79sec()
      write (stdout,'('' p79sec: t1 = '',F10.4, '' t2 = '',F10.4,
     x     '' t2-t1 = '',F10.4)') t1, t2, t2-t1
      write (stdout,'('' End test of p79sec'')')

      write (stdout,'(/'' Begin test of screen primitives...'')')
      n = p79clr(s)
      write (stdout,'('' p79clr: screen clear sequence: '',25i4)')
     x    (ichar(s(k:k)), k = 1,n)
      write (stdout,'('' p79col: screen width = '',i4)') p79col()
      write (stdout,'('' p79lin: screen lines = '',i4)') p79lin()
      write (stdout,'('' End test of screen primitives'')')

      write (stdout,'('' The status code on exit should be 23'')')
      call exit (23)
      end
